package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface OperationGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findResourceOperationHistoriesByCriteria( org.rhq.core.domain.criteria.ResourceOperationHistoryCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.operation.ResourceOperationHistory>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findGroupOperationHistoriesByCriteria( org.rhq.core.domain.criteria.GroupOperationHistoryCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.operation.GroupOperationHistory>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void deleteOperationHistory( int operationHistoryId, boolean deleteEvenIfInProgress, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findRecentCompletedOperations( int resourceId, org.rhq.core.domain.util.PageControl pageControl, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.operation.composite.ResourceOperationLastCompletedComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findCurrentlyScheduledResourceOperations( int pageSize, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.operation.composite.ResourceOperationScheduleComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findCurrentlyScheduledGroupOperations( int pageSize, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.operation.composite.GroupOperationScheduleComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void invokeResourceOperation( int resourceId, java.lang.String operationName, org.rhq.core.domain.configuration.Configuration parameters, java.lang.String description, int timeout, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void scheduleResourceOperation( org.rhq.core.domain.operation.bean.ResourceOperationSchedule resourceOperationSchedule, AsyncCallback<java.lang.Integer> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void scheduleGroupOperation( org.rhq.core.domain.operation.bean.GroupOperationSchedule groupOperationSchedule, AsyncCallback<java.lang.Integer> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void getResourceOperationSchedule( int scheduleId, AsyncCallback<org.rhq.core.domain.operation.bean.ResourceOperationSchedule> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void getGroupOperationSchedule( int scheduleId, AsyncCallback<org.rhq.core.domain.operation.bean.GroupOperationSchedule> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void unscheduleResourceOperation( org.rhq.core.domain.operation.bean.ResourceOperationSchedule resourceOperationSchedule, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void unscheduleGroupOperation( org.rhq.core.domain.operation.bean.GroupOperationSchedule groupOperationSchedule, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void scheduleResourceOperation( int resourceId, java.lang.String operationName, org.rhq.core.domain.configuration.Configuration parameters, java.lang.String description, int timeout, java.lang.String cronString, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findScheduledResourceOperations( int resourceId, AsyncCallback<java.util.List<org.rhq.core.domain.operation.bean.ResourceOperationSchedule>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findScheduledGroupOperations( int groupId, AsyncCallback<java.util.List<org.rhq.core.domain.operation.bean.GroupOperationSchedule>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void cancelOperationHistory( int historyId, boolean ignoreAgentErrors, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static OperationGWTServiceAsync instance;

        public static final OperationGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (OperationGWTServiceAsync) GWT.create( OperationGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "OperationGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
