package org.rhq.enterprise.gui.coregui.client.gwt;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ResourceGroupGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void createGroupDefinition( org.rhq.core.domain.resource.group.GroupDefinition groupDefinition, AsyncCallback<org.rhq.core.domain.resource.group.GroupDefinition> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void createPrivateResourceGroup( org.rhq.core.domain.resource.group.ResourceGroup group, int[] resourceIds, AsyncCallback<org.rhq.core.domain.resource.group.ResourceGroup> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void createResourceGroup( org.rhq.core.domain.resource.group.ResourceGroup group, int[] resourceIds, AsyncCallback<org.rhq.core.domain.resource.group.ResourceGroup> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void deleteGroupDefinitions( int[] groupDefinitionIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void deleteResourceGroups( int[] groupIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void findGroupDefinitionsByCriteria( org.rhq.core.domain.criteria.ResourceGroupDefinitionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.resource.group.GroupDefinition>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void findResourceGroupsByCriteria( org.rhq.core.domain.criteria.ResourceGroupCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.resource.group.ResourceGroup>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void findResourceGroupCompositesByCriteria( org.rhq.core.domain.criteria.ResourceGroupCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.resource.group.composite.ResourceGroupComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void setAssignedResourceGroupsForResource( int resourceId, int[] resourceGroupIds, boolean setType, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void setAssignedResources( int groupId, int[] resourceIds, boolean setType, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void recalculateGroupDefinitions( int[] groupDefinitionIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void updateGroupDefinition( org.rhq.core.domain.resource.group.GroupDefinition groupDefinition, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void updateResourceGroup( org.rhq.core.domain.resource.group.ResourceGroup group, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void updateResourceGroup( org.rhq.core.domain.resource.group.ResourceGroup group, boolean updateMembership, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void setRecursive( int groupId, boolean isRecursive, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ResourceGroupGWTServiceAsync instance;

        public static final ResourceGroupGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ResourceGroupGWTServiceAsync) GWT.create( ResourceGroupGWTService.class );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
